<?php

/**
 * Gadget - Joomla Template
 *
 * @package bt_gadget
 * @version 1.0
 * @copyright BonusThemes.com 2010
 * @link http://www.bonusthemes.com/goto/bt_gadget
 */

class PhotoSpotViewerGadgetTopAdmin extends PhotoSpotViewerAdmin {

	function setup() {
		$this->data_set('interval', '20');
		$this->data_set('speed', '10');
		$this->save();
	}

	function edit() {
		$load_data = true;

		if (JRequest::getCmd('hfrm_viewer_edit', '', 'POST') != '') {
			$load_data = false;
			$v_interval = trim($this->get('interval', '20'));
			$v_speed = trim($this->get('speed', '5'));


			if ($this->page_refreshed) {
				// ignore page refreshes
			}
			else if (JRequest::getCmd('btn_cancel', '', 'POST') != '') {
				// form cancelled
				$load_data = true;
			}
			else {
				// form submitted successfully

				$error_msg = '';

				if ($v_interval == '')
					$error_msg = JText::_('The value for the time interval is not set');
				else if (!ctype_digit($v_interval))
					$error_msg = JText::_('The value for the time interval is not a valid number');
				else if ($v_speed == '')
					$error_msg = JText::_('The value for the animation speed is not set');
				else if (!ctype_digit($v_speed))
					$error_msg = JText::_('The value for the animation speed is not a valid number');
				else if (intval($v_speed) < 1 || intval($v_speed) > 100)
					$error_msg = JText::_('The value for the animation speed must be between 1 - 100');

				if ($error_msg == '') {
					$this->data_set('interval', $v_interval);
					$this->data_set('speed', $v_speed);
					$this->save();

					global $mainframe;
					$mainframe->enqueueMessage(JText::_('Viewer updated successfully'));
				}
				else {
					JError::raiseWarning($error_msg, $error_msg);
				}
			}
		}

		if ($load_data) {
			$v_interval = $this->data_get('interval', '');
			$v_speed = $this->data_get('speed', '');
		}

		echo '
<form name="frm" method="post" action="index.php">
	<input type="hidden" name="hfrm_viewer_edit" value="' . microtime() . '" />
	<input type="hidden" name="option" value="' . htmlspecialchars(JRequest::getCmd('option')) . '" />
	<input type="hidden" name="task" value="' . htmlspecialchars(JRequest::getCmd('task')) . '" />
	<input type="hidden" name="id" value="' . htmlspecialchars(JRequest::getCmd('id')) . '" />

	<table cellspacing="10">
		<tr>
			<td>' . JText::_('Time interval') . '</td>
			<td><input type="text" name="interval" value="' . htmlspecialchars($v_interval) . '" size="5" /></td>
		</tr>
		<tr>
			<td>' . JText::_('Animation speed') . '</td>
			<td><input type="text" name="speed" value="' . htmlspecialchars($v_speed) . '" size="5" /></td>
		</tr>
	</table>

	<div>
		<input type="submit" name="btn_apply" value="' . JText::_('Apply') . '" />
		<input type="submit" name="btn_cancel" value="' . JText::_('Cancel') . '" />
	</div>
</form>
';
	}

}

$engine = new PhotoSpotViewerGadgetTopAdmin();

?>