/**
 * Main script for the BonusThemes.com Gadget Template
 *
 * @package bt_gadget
 * @version 1.0
 * @copyright BonusThemes.com 2010
 * @link http://www.bonusthemes.com/goto/bt_gadget
 */


function bt_add_event(obj, event, func) {
	if (obj.addEventListener)
		obj.addEventListener(event, func, false);
	else if (obj.attachEvent)
		obj.attachEvent('on' + event, func);
}


// CMenu handlers

function gadget_get_wdg(wdg_center) {
	return {
		left: wdg_center.previousSibling.nodeType == 1 ? wdg_center.previousSibling : wdg_center.previousSibling.previousSibling,
		center: wdg_center,
		right: wdg_center.nextSibling.nodeType == 1 ? wdg_center.nextSibling : wdg_center.nextSibling.nextSibling
	}
}

function gadget_ch_create(mi) {
	if (mi.is_header) {
		var wdg = gadget_get_wdg(mi.wdg);
		wdg.left.style.cursor = 'pointer';
		wdg.center.style.cursor = 'pointer';
		wdg.right.style.cursor = 'pointer';
	}
}

function gadget_ch_mouseover(mi) {
	if (document.page_loaded && mi.is_header) {
		var wdg = gadget_get_wdg(mi.wdg);

		mi.panel_ch_x = -23;
		mi.panel_ch_y = mi.wdg.offsetHeight - 18;

		var obj = mi.wdg;
		mi.panel_ch_x += obj.offsetLeft;
		obj = obj.offsetParent;
		while (obj) {
			mi.panel_ch_x += obj.offsetLeft;
			mi.panel_ch_y += obj.offsetTop;
			obj = obj.offsetParent;
		}
		mi.panel_ch_min_w = wdg.left.offsetWidth + wdg.center.offsetWidth + wdg.right.offsetWidth - 16;

		if (typeof mi.td_center_class == 'undefined') {
			mi.td_left_class = wdg.left.className;
			mi.td_center_class = wdg.center.className;
			mi.td_right_class = wdg.right.className;
		}

		if (mi.td_center_class == 'cmenu_hd_norm_empty_c' || mi.td_center_class == 'cmenu_hd_sel_empty_c') {
			wdg.left.className = 'cmenu_hd_hover_empty_l';
			wdg.center.className = 'cmenu_hd_hover_empty_c';
			wdg.right.className = 'cmenu_hd_hover_empty_r';
		}
		else if (mi.td_center_class == 'cmenu_hd_norm_full_c' || mi.td_center_class == 'cmenu_hd_sel_full_c') {
			wdg.left.className = 'cmenu_hd_hover_full_l';
			wdg.center.className = 'cmenu_hd_hover_full_c';
			wdg.right.className = 'cmenu_hd_hover_full_r';
		}
	}
}

function gadget_menu_close(mi) {
	if (document.page_loaded) {
		var wdg = gadget_get_wdg(mi.wdg);
		if (typeof mi.td_center_class != 'undefined') {
			wdg.left.className = mi.td_left_class;
			wdg.center.className = mi.td_center_class;
			wdg.right.className = mi.td_right_class;
		}
	}
}

function gadget_ch_mouseout(mi) {
	if (mi.is_header && mi.menuitems.length == 0)
		gadget_menu_close(mi);
}

function gadget_ch_panel_hide(mi) {
	if (mi.is_header)
		gadget_menu_close(mi);
}

document.r3_c1_y = 0;
document.r3_c2_y = 0;
function fix_heights() {
	var o1 = document.getElementById("r3_c1");
	var obj = o1, r3_c1_y = 0;
	while (obj) {
		r3_c1_y += obj.offsetTop;
		obj = obj.offsetParent;
	}

	var o2 = document.getElementById("r3_c2");
	var obj = o2, r3_c2_y = 0;
	while (obj) {
		r3_c2_y += obj.offsetTop;
		obj = obj.offsetParent;
	}

	if (r3_c1_y != document.r3_c1_y || r3_c2_y != document.r3_c2_y) {
		document.r3_c1_y = r3_c1_y;
		document.r3_c2_y = r3_c2_y;
		if (r3_c1_y > r3_c2_y) {
			o1.style.height = "10px";
			o2.style.height = (r3_c1_y - r3_c2_y + 10) + "px";
		}
		else {
			o1.style.height = (r3_c2_y - r3_c1_y + 10) + "px";
			o2.style.height = "10px";
		}
	}
}
setInterval("fix_heights()", 1000);


// page initialization

function gadget_page_init() {
	document.page_loaded = true;

	if (document['cmenu_items']) {
		document['mc'] = new CMenu({
			iname: 'mc',

			edge_min: 'r1_cnt',

			side: 'down',
			orientation: 'right',

			animate: true,
			anim_step: 10,
			anim_interval: 30,

			transparency: true,
			transparency_ie6: false,

			min_opacity: 0,
			max_opacity: 100,

			ch_create: gadget_ch_create,
			ch_mouseover: gadget_ch_mouseover,
			ch_mouseout: gadget_ch_mouseout,
			ch_panel_hide: gadget_ch_panel_hide,

			panel_offset1_x: 0,
			panel_offset1_y: 0,
			panel_offset2_x: 0,
			panel_offset2_y: 0,

			itemborder_class: 'cmenu_itemborder',
			separator_class: 'cmenu_separator',
			panel_class: 'cmenu_panel',
			panel_tl_class: 'cmenu_tl',
			panel_tc_class: 'cmenu_tc',
			panel_tr_class: 'cmenu_tr',

			subpanel_tl_class: 'cmenu_tl_sub',
			subpanel_tc_class: 'cmenu_tc_sub',
			subpanel_tr_class: 'cmenu_tr_sub',

			panel_ml_class: 'cmenu_ml',
			panel_mr_class: 'cmenu_mr',
			panel_bl_class: 'cmenu_bl',
			panel_bc_class: 'cmenu_bc',
			panel_br_class: 'cmenu_br',

			mi_empty_normal_class: 'cmenu_mi_empty_normal',
			mi_empty_hover_class: 'cmenu_mi_empty_hover',
			mi_full_normal_class: 'cmenu_mi_full_normal',
			mi_full_hover_class: 'cmenu_mi_full_hover'

		});

		var len = document['cmenu_items'].length;
		if (len > 0) {
			for (var i = 0; i < len; i++) {
				var item = document['cmenu_items'][i];

				if (typeof item.parent_id == 'undefined')
					this[item.id] = document['mc'].add_item(item);
				else
					this[item.id] = this[item.parent_id].add_item(item);
			}
		
			document['mc'].run();
		}
	}

	if (document["mod_gadget_top_conf"])
		mod_gadget_top_init();
}

bt_add_event(window, 'load', gadget_page_init);


var goto_top_type = -1;
function goto_top() {
	if (goto_top_type > -1)
		{ }
	else if (document.documentElement && document.documentElement.scrollTop)
		goto_top_type = 1;
	else if (document.body && document.body.scrollTop)
		goto_top_type = 2;

	var y = goto_top_type == 1 ? document.documentElement.scrollTop : document.body.scrollTop;
	if (y > 0) {
		y -= Math.ceil(y * 0.15);

		if (goto_top_type == 1)
			document.documentElement.scrollTop = y;
		else
			document.body.scrollTop = y;

		setTimeout("goto_top()", 50);
	}
}
