
/**
 * Gadget - Joomla Template
 *
 * @package bt_gadget
 * @version 1.0
 * @copyright BonusThemes.com 2010
 * @link http://www.bonusthemes.com/goto/bt_gadget
 */

document.mod_gadget_top_idle_secs = 5;

function mod_gadget_top_init() {
	var elements = document.getElementsByTagName("div");
	for (var i = 0, len = elements.length; i < len; i++) {
		if (elements[i].className == "mod_gadget_top_tr_l2" || elements[i].className == "mod_gadget_top_tr_l3") {
			var e = elements[i];
			var is_prev_button = e.className == "mod_gadget_top_tr_l2";

			var obj = e;
			while (obj) {
				if (obj.tagName == "DIV" && obj.id) {
					var m = obj.id.match(/mod_gadget_top_(\d+)/);
					if (m != null && document.mod_gadget_top_conf["inst_" + m[1]]) {
						conf = document.mod_gadget_top_conf["inst_" + m[1]];
						var iname = "mod_gadget_top_js_" + m[1];

						if (is_prev_button) {
							if (!document.mod_gadget_top_items)
								document.mod_gadget_top_items = new Array();

							document[iname] = new ModDisplayRotOne(iname, conf.speed, conf.interval, conf.countt);
							document[iname].change(1);
							document.mod_gadget_top_items.push(document[iname]);
						}

						e.setAttribute("iname", iname);

						if (is_prev_button)
							e.onclick = function () { document[this.getAttribute("iname")].change(-1); }
						else
							e.onclick = function () { document[this.getAttribute("iname")].change(1); }

						break;
					}
				}
				obj = obj.parentNode;
			}
		}
	}
}

function mod_gadget_top_mouse_moved(e) {
	document.mod_gadget_top_last_movement = (new Date).getTime();
}
mod_gadget_top_mouse_moved(null);

if (window.addEventListener)
	window.addEventListener("mousemove", mod_gadget_top_mouse_moved, false);
else
	document.attachEvent("onmousemove", mod_gadget_top_mouse_moved);

setInterval("mod_gadget_top_idle_timer()", 1000);

function mod_gadget_top_idle_timer() {
	if (((new Date).getTime() - document.mod_gadget_top_last_movement) / 1000 > document.mod_gadget_top_idle_secs) {
		document.mod_gadget_top_last_movement = (new Date).getTime();
		if (document.mod_gadget_top_items)
			for (var i = 0, len = document.mod_gadget_top_items.length; i < len; i++)
				document.mod_gadget_top_items[i].change(1);
	}
}

function ModDisplayRotOne(iname, speed, interval, countt) {
	this.idx = -1;
	this.iname = iname;
	this.speed = speed;
	this.interval = interval;
	this.progress = 0;
	this.countt = countt;

	this.wdg = null;

	this.wdg_hfx = document.getElementById("mod_gadget_top_" + this.iname.match(/\d+/) + "_hfx");
	this.wdg_hfx_y = 0;
	var obj = this.wdg_hfx;
	while (obj) {
		this.wdg_hfx_y += obj.offsetTop;
		obj = obj.offsetParent;
	}
}

ModDisplayRotOne.prototype.change = function (step) {
	document.mod_gadget_top_last_movement = (new Date).getTime();

	if (this.wdg != null)
		this.wdg.style.display = "none";

	if (this.idx == -1)
		this.idx = 0;
	else if (step == -1 && this.idx == 0)
		this.idx = this.countt - 1;
	else if (step == 1 && this.idx == this.countt - 1)
		this.idx = 0;
	else
		this.idx += step;

	this.wdg = document.getElementById("mod_gadget_top_" + this.iname.match(/\d+/) + "_" + this.idx + "_panel");

	this.progress = 0;
	this.h_timer();
}

ModDisplayRotOne.prototype.h_timer = function () {
	var opening = this.progress == 0;

	this.progress += this.speed;
	if (this.progress >= 100)
		this.progress = 100;

	var opacity = Math.round(this.progress);
	if (opacity == 0)
		opacity = 1;

	this.wdg.style.opacity = opacity / 100;
	this.wdg.style.filter = "alpha(opacity=" + opacity + ")";
	this.wdg.style.display = "block";

	if (opening) {
		var obj = this.wdg, wdg_y = this.wdg.offsetHeight;
		while (obj) {
			wdg_y += obj.offsetTop;
			obj = obj.offsetParent;
		}

		this.wdg_hfx.style.height = (wdg_y > this.wdg_hfx_y ? wdg_y - this.wdg_hfx_y : 0) + "px";
	}

	if (this.progress < 100)
		setTimeout("document['" + this.iname + "'].h_timer()", this.interval);
}
