<?php

/**
 * Gadget - Joomla Template
 *
 * @package bt_gadget
 * @version 1.0
 * @copyright BonusThemes.com 2010
 * @link http://www.bonusthemes.com/goto/bt_gadget
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

function BtMenuCntNewItem($base, $name, $link) {
	$result = new stdClass();
	$result->parent = $base;
	$result->is_active = false;
	$result->selection = 0;
	$result->type = 'link';
	$result->link = $link;
	$result->href = '';
	$result->name = $name;
	$result->image = '';
	$result->sub_menu_items = array();
	return $result;
}

class BtMenuCntCategory {

	function BtMenuCntCategory($id, $name, $published, $vendor_id) {
		$this->__construct($id, $name, $published, $vendor_id);
	}

	function __construct($id, $name, $published, $vendor_id) {
		$this->id = $id;
		$this->parent_id = null;
		$this->name = $name;
		$this->published = $published;
		$this->vendor_id = $vendor_id;
		$this->sub_items = array();
	}

	function read($base, $instance, $published, $cur_vendor, $depth) {

	}

}

class BtMenuCntLoader {

	function load_items($base, $instance, $query, $max_items, $link_Itemid) {
		$db =& JFactory::getDBO();

		$db->setQuery($query, 0, $max_items);
		$items = $db->loadObjectList();

		if (!empty($items)) {
			$i = 0;
			foreach ($items as $item) {
				$i++;
				$url = JRoute::_('index.php?option=com_content&view=article&id=' . $item->slug . '&catid=' . $item->catslug . $link_Itemid);
				$this->result['vm_' . $instance . '_' . $i] = BtMenuCntNewItem($base, JText::_($item->title), $url);
			}
		}
	}

	function load($base, $link) {
		$this->result = array();
		$elements = explode(':', $link);

		$vars = array();
		for ($i = 3, $len = count($elements); $i < $len; $i++) {
			$e = explode('=', $elements[$i], 2);
			if (count($e) == 2)
				$vars[strtolower($e[0])] = $e[1];
		}

		static $instance = 0;

		static $db = null;
		static $aid = null;
		static $noauth = null;
		static $now = null;
		static $nullDate = null;
		if ($db === null) {
			$db =& JFactory::getDBO();

			$user =& JFactory::getUser();
			$aid = $user->get('aid', 0);

			$contentConfig =& JComponentHelper::getParams('com_content');
			$noauth = !$contentConfig->get('show_noauth');
			$date =& JFactory::getDate();
			$now = $date->toMySQL();

			$nullDate = $db->getNullDate();

			require_once(JPATH_SITE . '/components/com_content/helpers/route.php');
		}

		$max_items = isset($vars['max']) ? (int) $vars['max'] : 0;
		if ($max_items <= 0)
			$max_items = 10;

		$cat = isset($vars['cat']) ? $vars['cat'] : '';
		preg_match_all('/[0-9]+/', $cat, $cat_ids);

		$sec = isset($vars['sec']) ? $vars['sec'] : '';
		preg_match_all('/[0-9]+/', $sec, $sec_ids);

		$link_Itemid = isset($vars['itemid']) && ctype_digit($vars['itemid']) ? '&Itemid=' . $vars['itemid'] : '';

		switch ($elements[2]) {
			case 'articles':
				$query =
'SELECT a.title,
CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,
CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug
FROM #__content AS a
INNER JOIN #__categories AS cc ON cc.id = a.catid
INNER JOIN #__sections AS s ON s.id = a.sectionid
WHERE
' . (empty($cat_ids[0]) ? '' : 'a.catid IN (' . implode(",", $cat_ids[0]) . ') AND') . '
' . (empty($sec_ids[0]) ? '' : 'a.sectionid IN (' . implode(",", $sec_ids[0]) . ') AND') . '
a.state = 1
' . ($noauth ? ' AND a.access <= ' . (int) $aid . ' AND cc.access <= ' . (int) $aid . ' AND s.access <= ' . (int) $aid : '') . '
AND (a.publish_up = ' . $db->Quote($nullDate) . ' OR a.publish_up <= ' . $db->Quote($now) . ')
AND (a.publish_down = ' . $db->Quote($nullDate) . ' OR a.publish_down >= ' . $db->Quote($now) . ')
AND cc.section = s.id
AND cc.published = 1
AND s.published = 1
ORDER BY a.ordering';

				$instance++;
				$this->load_items($base, $instance, $query, $max_items, $link_Itemid);

				break;

			case 'latest':
				$query =
'SELECT a.title,
CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,
CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug
FROM #__content AS a
INNER JOIN #__categories AS cc ON cc.id = a.catid
INNER JOIN #__sections AS s ON s.id = a.sectionid
WHERE
' . (empty($cat_ids[0]) ? '' : 'a.catid IN (' . implode(",", $cat_ids[0]) . ') AND') . '
' . (empty($sec_ids[0]) ? '' : 'a.sectionid IN (' . implode(",", $sec_ids[0]) . ') AND') . '
a.state = 1
' . ($noauth ? ' AND a.access <= ' . (int) $aid . ' AND cc.access <= ' . (int) $aid . ' AND s.access <= ' . (int) $aid : '') . '
AND (a.publish_up = ' . $db->Quote($nullDate) . ' OR a.publish_up <= ' . $db->Quote($now) . ')
AND (a.publish_down = ' . $db->Quote($nullDate) . ' OR a.publish_down >= ' . $db->Quote($now) . ')
AND cc.section = s.id
AND cc.published = 1
AND s.published = 1
ORDER BY a.created DESC';

				$instance++;
				$this->load_items($base, $instance, $query, $max_items, $link_Itemid);

				break;

			case 'random':
				$query =
'SELECT a.title,
CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,
CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug
FROM #__content AS a
INNER JOIN #__categories AS cc ON cc.id = a.catid
INNER JOIN #__sections AS s ON s.id = a.sectionid
WHERE
' . (empty($cat_ids[0]) ? '' : 'a.catid IN (' . implode(",", $cat_ids[0]) . ') AND') . '
' . (empty($sec_ids[0]) ? '' : 'a.sectionid IN (' . implode(",", $sec_ids[0]) . ') AND') . '
a.state = 1
' . ($noauth ? ' AND a.access <= ' . (int) $aid . ' AND cc.access <= ' . (int) $aid . ' AND s.access <= ' . (int) $aid : '') . '
AND (a.publish_up = ' . $db->Quote($nullDate) . ' OR a.publish_up <= ' . $db->Quote($now) . ')
AND (a.publish_down = ' . $db->Quote($nullDate) . ' OR a.publish_down >= ' . $db->Quote($now) . ')
AND cc.section = s.id
AND cc.published = 1
AND s.published = 1
ORDER BY RAND()';

				$instance++;
				$this->load_items($base, $instance, $query, $max_items, $link_Itemid);

				break;

			case 'selected':
				if (!empty($vars['id'])) {
					preg_match_all('/[0-9]+/', $vars['id'], $prd_ids);
					if (!empty($prd_ids[0])) {
						$query =
'SELECT a.title,
CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,
CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug
FROM #__content AS a
INNER JOIN #__categories AS cc ON cc.id = a.catid
INNER JOIN #__sections AS s ON s.id = a.sectionid
WHERE
' . (empty($prd_ids[0]) ? '' : 'a.id IN (' . implode(",", $prd_ids[0]) . ') AND') . '
' . (empty($cat_ids[0]) ? '' : 'a.catid IN (' . implode(",", $cat_ids[0]) . ') AND') . '
' . (empty($sec_ids[0]) ? '' : 'a.sectionid IN (' . implode(",", $sec_ids[0]) . ') AND') . '
a.state = 1
' . ($noauth ? ' AND a.access <= ' . (int) $aid . ' AND cc.access <= ' . (int) $aid . ' AND s.access <= ' . (int) $aid : '') . '
AND (a.publish_up = ' . $db->Quote($nullDate) . ' OR a.publish_up <= ' . $db->Quote($now) . ')
AND (a.publish_down = ' . $db->Quote($nullDate) . ' OR a.publish_down >= ' . $db->Quote($now) . ')
AND cc.section = s.id
AND cc.published = 1
AND s.published = 1';

						$instance++;
						$this->load_items($base, $instance, $query, $max_items, $link_Itemid);
					}
				}
				break;

		}

		return $this->result;
	}

}

?>